package coding_theory_quaternary;

import java.io.*;
import java.util.*;
//Final code date 23-12-2015
public class Solution 
{
	public static PrintWriter pwriter, tablewriter, regularwriter,rwriter;
	private static final Runtime r = Runtime.getRuntime();
	public static void main(String args[])throws Exception
	{
		BufferedReader rd = new BufferedReader(new InputStreamReader(System.in));

		/*System.out.println("Enter the value of n (Length of codewords) :");
        int n=Integer.parseInt(rd.readLine());
        System.out.println("Enter the distance d (Hamming distance) :");
        int d=Integer.parseInt(rd.readLine());
        System.out.println("Enter the value of w  GC) :");
        int gc_wt=Integer.parseInt(rd.readLine());*/
		/*System.out.println("Enter the value of k (max. 0's between two consecutive 1's) :");
        int k=Integer.parseInt(rd.readLine());
        System.out.println("Enter the value of d1 (min. 0's between two consecutive 1's) :");
        int d1=Integer.parseInt(rd.readLine());
		 */


		rwriter = new PrintWriter(new File("List1.html"));
		//System.out.println(a3[0]+"\t\t"+a3[1]);
		rwriter.write("<html><body>");
		rwriter.write("<table border="+2+"><tr><th align=center>n/d</th>");
		for(int jh=3;jh<12;jh++)
		{
			rwriter.write("<th align=center>"+jh+"</th>");
		}
		rwriter.write("</tr>");
		for(int gh=4;gh<11;gh++)//starting and ending length
		{
			rwriter.write("<tr>");
			rwriter.write("<td align =center>"+gh+"</td>");
			for(int i3=3;i3<=gh;i3++)//starting and ending distance
			{
				ArrayList<Long[]> code=make_codes(gh);
				code = altruistic(gh,i3,gh/2,code);
				code = reverse_complement(code,gh,i3);
				code = reverse_constraint(code,gh,i3);
				
				//code=GC_constraint(code,gh,i3,gh/2,gh*2);
				if(i3 > gh)
				{
					String s = "-";
					rwriter.write("<td align=center>"+s+"</td>");
				}
				else
				{
					int n9=code.size();
					String n7 = gh+"_"+i3+"_"+gh/2;
					pwriter = new PrintWriter(new File(n7+".html"));
					pwriter.println("<html>\n<body>\n<h1>");
					pwriter.println("<h3>Number of codewords for n = "+ gh +" d = " + i3 +" GC-content = " + gh/2 + " are " + code.size() + " </h3>" );        
					print2(code,gh);
					pwriter.println("</body>\n</html");
					pwriter.close();
					rwriter.write("<td align=center><a href="+n7+".html>"+code.size()+"</a></td>");
				}
			}
			rwriter.write("</tr>");
			System.gc();
		}
		rwriter.write("</body></html>");
		rwriter.close();
	}

	public static ArrayList<Long[]> make_codes(int n) throws FileNotFoundException
	{
		ArrayList<Long[]> code = new ArrayList<Long[]>();
		Long[] a=new Long[n];
		Long abc=new Long(0);
		for(int h=0;h<n;h++) //O(n)
		{
			a[h]=abc;
		}

		Long[] b=new Long[n];
		double total=Math.pow(4,n);
		total=total-1;
		for(int i=0;i<total;i++) //(O(2^n)*2*(n+1)) times)
		{
			//if and else will be executing 2*O(n+1) times

			if(i%2==0)
			{
				b=increment(a,n); //O(n)
				int g=GC_constant(a,n,2);
				int h=GC_constant(a,n,3);
				g=g+h;
				int res = constraint(a,n);
				if(res==1 && g==n/2)
				{
					code.add(a); //O(1)
				}

			}
			else
			{
				a=increment(b,n);
				int g=GC_constant(b,n,2);
				int h=GC_constant(b,n,3);
				g=g+h;
				int res = constraint(b,n);
				if(res==1 && g==n/2)
				{
					code.add(b);//O(1)
				}
			}
		}
		return code;
	}
	//correlated and uncorrelated constraints
	public static ArrayList<Long[]> co_un(ArrayList<Long[]> n,int arr)
	{
		Long[] ar22 = new Long[arr];
		Long[] ar11 = new Long[arr];
		for (int xx =0 ; xx<n.size() ; xx++)
		{
			ar11 = n.get(xx);
			for (int yy = 0 ; yy<n.size(); yy++)
			{
				if(xx!=yy)
				{
					ar22= n.get(yy);
					for(int k=0;k<ar22.length;k++)
					{
						if(compare(ar11,ar22,k)==0)
						{
							n.remove(yy);
							if(yy < xx)
								xx--;
							yy--;
							break;
						}//break;
					}
				}
			}
		}
		return n;
	}

	//helper function
	public static int  compare(Long arr[] , Long arr2[],int y)
	{
		for(int i = y, j = 0  ;i<arr.length && j <(arr2.length - y); i++ , j++)
		{
			if(arr[i] == arr2[j])
			{
				return 0;
			}
		}
		return 1;
	}
	public static ArrayList<Long[]> altruistic(int n, int d,int gc_wt,ArrayList<Long[]> code2)throws FileNotFoundException
	{
		int pos_max=0;
		int hd;
		System.out.println("code " + " " + code2.size());
		while(true) ////O(c((c*2 * n)+ c + c + c)
		{
			int[] w=new int[code2.size()];
			//while loop idhar se start krna
			for(int j=0;j<code2.size();j++)            
			{
				Long[] c=code2.get(j);
				for(int k2=0;k2<code2.size();k2++)
				{
					hd=weight(c,code2.get(k2),n); //O(n)

					if(hd<=(d-1))
						w[j]=w[j]+1;
				}
			}

			System.out.println();
			//print(w,n);
			pos_max=maximum(w); //O(c)
			//System.out.println();
			if(pos_max==1)
				break;
			else
			{

				for(int m=0;m<w.length;m++) //O(c)
				{
					if(w[m]==pos_max)
					{
						System.out.println(pos_max + " is maximum value at index " + m );
						code2.remove(m);
						//System.out.print(" is removed "); 
						break;
					}
				}
			}    
		}

		// 0-A , 1-T , 2-G , 3-C
		long lEndTime = System.currentTimeMillis();
		String n7 = n+"_"+d+"_"+gc_wt;
		pwriter = new PrintWriter(new File(n7+".html"));
		pwriter.println("<html>\n<body>\n<h1>");
		//pwriter.println("n="+n+", d="+d+", theta="+theta+"  ("+isomorphNo+")</h1>");
		pwriter.println("<h3>Matrix</h3>");        
		print2(code2,n);
		pwriter.println("</body>\n</html");
		pwriter.close();

		System.out.println("Finally done " + code2.size());
		r.freeMemory();
		return code2;
	}


	public static ArrayList<Long[]> reverse_complement(ArrayList<Long[]> code2,int n,int d)
	{
		for(int j=0;j<code2.size();j++)            
		{
			Long[] c=code2.get(j);
			c=complement(c,n);
			for(int k2=0;k2<code2.size();k2++)
			{
				if(k2!=j)
				{
					Long[] d3=new Long[n];
					d3=reverse(code2.get(k2),n);
					int hd=weight(c,d3,n); //O(n)
					if(hd<d)
					{
						code2.remove(k2);
						k2--;
					}
				}
			}
		}
		return code2;
	}
	
	public static ArrayList<Long[]> reverse_constraint(ArrayList<Long[]> code2,int n,int d)
	{
		for(int j=0;j<code2.size();j++)            
		{
			Long[] c=code2.get(j);
			for(int k2=0;k2<code2.size();k2++)
			{
				if(k2!=j)
				{
					Long[] d3=new Long[n];
					d3=reverse(code2.get(k2),n);
					int hd=weight(c,d3,n); //O(n)
					if(hd<d)
					{
						code2.remove(k2);
						k2--;
					}
				}
			}
		}
		return code2;
	}

	public static int minimum(int[] find,int size)
	{
		int min=find[0];
		int i=0;
		while(i<size)
		{
			if(min>find[i])
			{
				min=find[i];
			}
			if(min<=find[i])
			{
				i++;
			}
		}
		return min;
	}

	public static int min_energy(int[][] e,int n)
	{
		int min_energy=0,j=0;
		int len=n;
		for(int i=0;i<len;i++)
		{ 
			j=0;
			while(j<=len)
			{
				if(e[i][j]<=min_energy)
				{
					min_energy=e[i][j];

				}
				j++;
			}
		}
		return min_energy;
	}    

	public static int GC_constant(Long[] a,int n,int f)
	{
		int ct=0;
		for(int i=0;i<n;i++)
		{
			if(a[i]==f)//|| a[i]==3)
				ct++;
		}
		return ct;
	}

	public static Long[] reverse(Long[] a,int n)
	{
		Long[] b=new Long[n];
		int s=n-1;
		for(int i=0;i<n;i++)
		{
			b[s--]=a[i];
		}
		return b;
	}

	public static Long[] complement(Long[] a,int n)
	{
		Long[] b=new Long[n];
		//b=reverse(a,n);
		Long a1=new Long(1);
		Long a2=new Long(2);
		Long a3=new Long(3);
		Long a0=new Long(0);
		for(int i=0;i<n;i++)
		{
			if(a[i]==0)
				b[i]=a1;
			else if(a[i]==1)
				b[i]=a0;
			else if(a[i]==2)
				b[i]=a3;
			else
				b[i]=a2;
		}
		return b;
	}

	public static int constraint(Long[] a,int n)
	{
		for(int i=1;i<n;i++)
		{
			if(a[i].equals(a[i-1]))
			{
				return 0;
			}    
		}    
		return 1;
	}


	public static int weight(Long[] a,Long[] b,int n)
	{
		int count=0;

		for(int i=0; i<n; i++) //O(n)
		{
			if(a[i].compareTo(b[i])!=0)
				count++;
		}

		return count;
	}
	public static Long[] increment(Long[] a,int n) //O(n) + O(n)
	{
		//System.out.println("add");
		Long[] b=new Long[n];
		Long[] c=new Long[n];
		Long pqr=new Long(0);
		Long rst=new Long(1);
		for(int h=0;h<n;h++)    //O(n)
		{
			if(h!=(n-1))
			{
				b[h]=pqr;
				c[h]=pqr;
			}
			else
			{
				b[h]=rst;
				c[h]=pqr;
			}
		}

		for(int i=n-1;i>=0;i--) //O(n)
		{
			c[i] = c[i]+add_mod4(a[i],b[i]);
			if(c[i]>=4)
			{
				c[i]=pqr;
				if((i-1)>=0 && (i-1)< (n-1)) //O(2)
				c[i-1]=rst;
			}
			//System.out.print(c[i]);
		}
		return c;
	}

	public static Long add_mod4(Long a,Long b) //O(1)
	{
		//Long[] x=new Long[n];
		if((a+b)>=4)
			return (10+(a+b)%4);
		else
			return a+b;
	}

	public static int maximum(int a[])
	{
		int max=a[0],h;
		for(h=1;h<a.length;h++)
		{
			if(a[h]>max)
			{
				max=a[h];
			}  
		}
		return max;
	}

	public static void print(Long a[],int n)
	{
		System.out.println("\n");
		for(int i=0;i<n;i++)
		{
			System.out.print("  "+ a[i]);
		}
	}

	public static void print2(ArrayList<Long[]> a,int n)
	{
		//int n;
		String abcd="Sr. No." ;
		String pqrs="Codewords ";
		pwriter.write("<table border="+1+"><tr><th align=center>"+abcd+"</th><th align=center>"+pqrs+"</th></tr>");
		//System.out.println(a1[0] + "\t\t" + a1[1]);
		for(int j1=0;j1<a.size();j1++)
		{
			pwriter.write("<tr>");
			System.out.print((j1+1)+"\t\t");
			//pwriter.write(" j1+1 ");
			pwriter.write("<td align=center>"+(j1+1)+"</td>");
			pwriter.write("<td align=center>");
			Long[] b=a.get(j1);
			System.out.print(j1 + ".");
			for(int k1=0;k1<n;k1++)
			{
				if(b[k1]==0)
				{
					System.out.print("  " + "A");
					pwriter.write("  "+ "A");
				}
				else if(b[k1]==1)
				{
					System.out.print("  " + "T");
					pwriter.write("  "+ "T");
				}
				else if(b[k1]==2)
				{
					System.out.print("  " + "G");
					pwriter.write("  "+ "G");
				}
				else if(b[k1]==3)
				{
					System.out.print("  " + "C");
					pwriter.write("  "+ "C");
				}
				//System.out.print("  " + b[k1]);

			}
			System.out.print("\n");
			pwriter.print("</td></tr>");
		}
		pwriter.println("<br />");
	}
}


