//For Z_{2^m} + wZ_{2^m} input m and output element, product and addition table

package allRingsz4;

import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import java.io.*;
import java.util.*;

public class Sol 
{
	static Workbook workbook = new XSSFWorkbook();
	static ArrayList<String> ring = new ArrayList<String>();
	public static void main(String[] args) throws Exception
	{
		BufferedReader rd = new BufferedReader(new InputStreamReader(System.in));
		System.out.println("Enter m :");
		int m = Integer.parseInt(rd.readLine());
		int n = (int) Math.pow(2,m);
		int l=0;
		int[] code1 = new int[n*n];//Omega_w
		int[] code2 = new int[n*n];//Constant
		System.out.println("For field on Z"+ n +", the no of codewords are "+ n*n );
		for(int i=0;i<n*n;i++)
		{
			code1[i]=l%n;
			l++;
		}
		l=0;
		for(int i=0;i<n*n;i++)
		{
			code2[i]=l%n;
			if(i>0 && (i+1)%n==0)
				l++;
		}
		System.out.println(" Elements are :\n");
		String temp=null;
		for(int i=0;i<n*n;i++)
		{
			temp=code2[i]+"w + "+code1[i];
			System.out.println((i+1)+"." +code2[i]+"w + "+code1[i]);
			ring.add(temp);
		}
		l=0;
		/*
	   System.out.println("Enter any equation you want in the form of a#bw which represents a+bw");
       String input = rd.readLine();
       String[] abcd = input.split("#");
       int a = Integer.parseInt(abcd[0]);
       int b=0,k=abcd[1].length()-2;
       for(int i=0;i<abcd[1].length()-1;i++,k--)
       {
    	   int y= Character.getNumericValue(abcd[1].charAt(i))*(int)Math.pow(10, k);
    	   b = b+y;
       }
       int sum1=0;//omega
       int sum2=0;//constant
       
       System.out.println("C + Cr = "+ a + "+"+ b + "w " +" and C+ " + a + " + "+ b + " w " +"= C^c.");
       System.out.println("So below are the pairs following this :");
       for(int i=0;i<n*n;i++)
       {
    	   for(int j=0;j<n*n;j++)
           {
    		   sum1=(code1[i]+code1[j])%n;
    		   sum2=(code2[i]+code2[j])%n;
    		   if(sum1==a && sum2==b)
    		   {
    			  // int[] d =complement(code2[i],code1[i],n);
    			   /*if(m==2)
    			   {
    				   String ab = map(code2[i],code1[i]);
    				   String cd = map(code2[j],code1[j]);
    				   String ef = map(d[0],d[1]);//a+ub
    				   System.out.println((l+1)+". "+ ab + " *******  "+ cd + " ******** " + ef );
    			   }
    			   int p=(code2[j]+8)%n;
    			   int q=(code1[j]+8)%n;
    			   System.out.println((l+1)+". " +code2[i]+"w + "+code1[i]+" ******** "+code2[j]+"w + "+code1[j]+" " + " ********** "+ p+"w +" + q);
    			   l++;
    		   } 
           }
       }*/
		
		System.out.println("Enter 1 for product table and 2 for addition table");
		int c = Integer.parseInt(rd.readLine());
		if(c==1)
			product(code1,code2,n);
		else if (c==2)
			add(code1,code2,n);
		else
			System.out.println("Wrong input");			
	}

	public static void add(int[] code1,int[] code2,int n)throws Exception
	{
		int ri=0;
		int sum1=0,sum2=0;
		ArrayList<String[]> p = new ArrayList<String[]>();
		String[] abc = new String[n*n];
		Sheet studentsSheet = workbook.createSheet("Addition");
		System.out.println("Addition Table is : ");
		for(int i=0;i<n*n;i++)
		{
			Row row = studentsSheet.createRow(ri++);
			int cellIndex = 1;
			if(i==0)
			{	
				//cellIndex=1;
				for(int p1=0;p1<n*n;p1++)
				{
					String g=code2[p1]+"w + "+code1[p1];
					row.createCell(cellIndex++).setCellValue(g);
				}
				row = studentsSheet.createRow(ri++);
				cellIndex=1;
			}
			for(int j=0;j<n*n;j++)
			{
				if(cellIndex==1 || j==0)
				{
					String g=code2[i]+"w + "+code1[i];
					row.createCell(0).setCellValue(g);
				}	

				sum1=(code1[i]+code1[j])%n;
				sum2=(code2[i]+code2[j])%n;
				if(sum1==0 && sum2==0)
					abc[j]="0";
				else if (sum2==0 && sum1==1)
					abc[j]="1";
				else
					abc[j]=sum2 + "w +" + sum1;
				row.createCell(cellIndex++).setCellValue(abc[j]);
				System.out.print(abc[j] + "  ");
			}
			System.out.println();
			p.add(abc);
		}
		try (FileOutputStream outputStream = new FileOutputStream("Addition.xlsx")) 
		{
			workbook.write(outputStream);
		}
	}

	public static void product(int[] code1,int[] code2,int n)throws Exception
	{
		int ri=0;
		Sheet studentsSheet = workbook.createSheet("Product");

		ArrayList<String[]> p = new ArrayList<String[]>();
		String[] abc = new String[n*n];

		int pr1=0,pr2=0;
		System.out.println("Multiplication Table is : ");
		for(int i=0;i<n*n;i++)
		{
			Row row = studentsSheet.createRow(ri++);
			int cellIndex = 1;
			if(i==0)
			{	
				//cellIndex=1;
				for(int p1=0;p1<n*n;p1++)
				{
					String g=code2[p1]+"w + "+code1[p1];
					row.createCell(cellIndex++).setCellValue(g);
				}
				row = studentsSheet.createRow(ri++);
				cellIndex=1;
			}
			for(int j=0;j<n*n;j++)
			{
				if(cellIndex==1 || j==0)
				{
					String g=code2[i]+"w + "+code1[i];
					row.createCell(0).setCellValue(g);
				}	

				//constant term
				pr1=((code1[i]*code1[j])+(2*code2[i]*code2[j]))%n;

				//omega term
				pr2=((code2[i]*code1[j])+(code1[i]*code2[j])+(2*code2[i]*code2[j]))%n;
				/*if((code2[i]==0 && code1[i]==0)||(code2[j]==0 && code2[i]==0))
				{
					if(pr1==0 || pr2==0)
						
					*/	
				if(pr1==0 && pr2==0)
					abc[j]="0";
				else
					abc[j]=pr1 + "+" + pr2 + "w";
				row.createCell(cellIndex++).setCellValue(abc[j]);
				if(code2[i]==8 && code1[i]==0)
					System.out.println(code2[i]+"w +" + code1[i]+ " times " + code2[j]+"w +" + code1[j]+" is "+abc[j] );
				System.out.print(abc[j] + "  ");
			}
			System.out.println();
			p.add(abc);
		}
		try (FileOutputStream outputStream = new FileOutputStream("Product.xlsx")) 
		{
			workbook.write(outputStream);
		}
		}
	

	public static void zd()throws Exception
	{
		String excelFilePath = "Product.xlsx";
		FileInputStream inputStream = new FileInputStream(new File(excelFilePath));

		Workbook workbook = new XSSFWorkbook(inputStream);
		Sheet firstSheet = workbook.getSheetAt(0);
		Iterator<Row> iterator = firstSheet.iterator();

		while (iterator.hasNext()) 
		{
			Row nextRow = iterator.next();
			Iterator<Cell> cellIterator = nextRow.cellIterator();
			String temp=null;

			while (cellIterator.hasNext()) {
				Cell cell = cellIterator.next();
				temp = cell.getStringCellValue();
				if(temp.equals("0"))
				{
					 
				}
			}
			System.out.println();
		}

		workbook.close();
		inputStream.close();
	}

	public static String map(int a,int b)//a+ub
	{
		if(a==0)
		{
			if(b==0)
				return "AT";
			else if(b==1)
				return "AG";
			else if(b==2)
				return "GC";
			else if(b==3)
				return "CT";
			else
				return "PP";
		}
		if(a==1)
		{
			if(b==0)
				return "AC";
			else if(b==1)
				return "AA";
			else if(b==2)
				return "CA";
			else if(b==3)
				return "CC";
			else
				return "PP";
		}
		if(a==2)
		{
			if(b==0)
				return "CG";
			else if(b==1)
				return "GA";
			else if(b==2)
				return "TA";
			else if(b==3)
				return "TC";
			else
				return "PP";
		}
		if(a==3)
		{
			if(b==0)
				return "GT";
			else if(b==1)
				return "GG";
			else if(b==2)
				return "TG";
			else if(b==3)
				return "TT";
			else
				return "PP";
		}
		else
			return "QQ";
	}

	public static int[] complement(int a , int b,int n)
	{
		int sum1,sum2; 
		sum1=(a+2)%n;
		sum2=(b+2)%n;
		int[] f = new int[2];
		f[0]=sum1;
		f[1]=sum2;
		return f;
	}
}

